/* Sistemas Integrados TEKNISA

Nome: 6705_ORETRGS_GRAVA_HISTORCAEVEN.sql

Descrio:
   GRAVA O HISTRICO DE ALTERAO DA SITUAO DO ORAMENTO

Criao:
  29/03/2007 Andr Rodrigo de Carvalho
*/

IF EXISTS (SELECT NAME
           FROM SYSOBJECTS
           WHERE
              NAME = 'GRAVA_HISTORCAEVEN' AND
              TYPE = 'TR')
   DROP TRIGGER GRAVA_HISTORCAEVEN
GO

CREATE TRIGGER GRAVA_HISTORCAEVEN
ON ORCAEVENTO
FOR INSERT, UPDATE

AS

DECLARE @V_NEW_CDFILIAL      VARCHAR(04);
DECLARE @V_NEW_NRORCAEVENTO  VARCHAR(10);
DECLARE @V_NEW_NRSEQORCAEVE  VARCHAR(02);
DECLARE @V_OLD_IDSITUORCEVE  VARCHAR(01);
DECLARE @V_NEW_IDSITUORCEVE  VARCHAR(01);
DECLARE @V_NEW_CDOPEJUSTORC  VARCHAR(12);
DECLARE @V_EXISTE_HIST       FLOAT;

BEGIN
   DECLARE C_INSERTED CURSOR FOR
      SELECT
         INSERTED.CDFILIAL, INSERTED.NRORCAEVENTO, INSERTED.NRSEQORCAEVE,
         INSERTED.IDSITUORCEVE OLD_IDSITUORCEVE, INSERTED.IDSITUORCEVE NEW_IDSITUORCEVE,
         INSERTED.CDOPEJUSTORC
      FROM
         INSERTED
      WHERE INSERTED.CDOPEJUSTORC IS NOT NULL
        AND 0 = (SELECT COUNT(*) FROM DELETED)

      UNION ALL

      SELECT
         INSERTED.CDFILIAL, INSERTED.NRORCAEVENTO, INSERTED.NRSEQORCAEVE,
         DELETED.IDSITUORCEVE OLD_IDSITUORCEVE, INSERTED.IDSITUORCEVE NEW_IDSITUORCEVE,
         INSERTED.CDOPEJUSTORC
      FROM
         INSERTED,
         DELETED
      WHERE INSERTED.CDOPEJUSTORC IS NOT NULL
        AND INSERTED.CDFILIAL     = DELETED.CDFILIAL
        AND INSERTED.NRORCAEVENTO = DELETED.NRORCAEVENTO
        AND INSERTED.NRSEQORCAEVE = DELETED.NRSEQORCAEVE
        AND DELETED.IDSITUORCEVE <> INSERTED.IDSITUORCEVE;
   OPEN C_INSERTED;
   FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDFILIAL,     @V_NEW_NRORCAEVENTO, @V_NEW_NRSEQORCAEVE,
                                   @V_OLD_IDSITUORCEVE, @V_NEW_IDSITUORCEVE, @V_NEW_CDOPEJUSTORC;
   WHILE (@@FETCH_STATUS = 0) BEGIN
   /*   IF ISNULL(@V_OLD_IDSITUORCEVE, 'W') <> ISNULL(@V_NEW_IDSITUORCEVE, 'W') BEGIN */
         SELECT @V_EXISTE_HIST = COUNT(CDFILIAL)
         FROM HISTORCAEVEN
         WHERE CDFILIAL     = @V_NEW_CDFILIAL
           AND NRORCAEVENTO = @V_NEW_NRORCAEVENTO
           AND NRSEQORCAEVE = @V_NEW_NRSEQORCAEVE
           AND CDOPERADOR   = @V_NEW_CDOPEJUSTORC
           AND DTHRHISTORCA = GETDATE();

         IF @V_EXISTE_HIST = 0 BEGIN
            INSERT INTO HISTORCAEVEN
               (CDFILIAL,     NRORCAEVENTO, NRSEQORCAEVE, CDOPERADOR,
                DTHRHISTORCA, IDSITANTHORC, IDSITATUHORC)
            VALUES
               (@V_NEW_CDFILIAL,  @V_NEW_NRORCAEVENTO, @V_NEW_NRSEQORCAEVE, @V_NEW_CDOPEJUSTORC,
                GETDATE(),        @V_OLD_IDSITUORCEVE, @V_NEW_IDSITUORCEVE);
         END;
/*      END;  */

      FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDFILIAL,     @V_NEW_NRORCAEVENTO, @V_NEW_NRSEQORCAEVE,
                                      @V_OLD_IDSITUORCEVE, @V_NEW_IDSITUORCEVE, @V_NEW_CDOPEJUSTORC;
   END;
   CLOSE C_INSERTED;
   DEALLOCATE C_INSERTED;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_HISTORCAEVEN','5.05.009';
GO

